; 
    include \masm32\include\masm32rt.inc
    .586
    .xmm
	include \masm32\macros\timers.asm

; 
comment *Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros - lingo *
.code
option prologue:none  ; turn it off
option epilogue:none  ;
align  16             ;
bin2asciiL proc lpbuf:DWORD, nNumber:DWORD
mov 	eax, [esp+2*4]			; eax ->number
mov 	edx, 89705F41h 		; 1e-9 * 2^61 rounded
cmp eax,-1
mov	ecx, eax				;
je @f
add  eax, 1
@@:
mul 	edx 				; Divide by 1e9 by multiplying with reciprocal.
mov	[esp+2*4], edi			;
shr 	edx, 29 				; Leading decimal digit, 0...4
imul 	eax, edx, 1000000000 	; Leading digit * 1e9
mov	edi,  [esp+1*4]			; edi ->buffer
sub 	eax, ecx 			; Subtract (leading digit * 1e9) from argument.
lea	ecx,  [edx+30h]
mov 	edx, 0ABCC7712h 		; 2^28 / 1e8 * 2^30 rounded up
neg	eax
mul 	edx 				; Divide reduced
mov 	[edi], cl 				; Store leading digit
cmp 	ecx, 31h			; Any nonzero digit yet?
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
shr 	eax,  30 				; argument < 1e9 by 1e8,
lea 	eax,  [eax+4*edx+1]		; converting it into 4.28 fixed-point
mov 	edx, 0FFFFFFFh
and 	edx, eax ;  0FFFFFFFh 		; Fraction part

shr 	eax,  28 				; Next digit
add	ecx, eax
add 	eax,  30h 			; Convert digit to ASCII.
cmp 	ecx,  31h			; Any nonzero digit yet?
mov 	[edi], al 				; Store digit in memory
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
lea 	eax,  [edx*4+edx] 		; 5 * fraction, new digit EAX[31-27]
mov               edx,  7FFFFFFh  		; 5 * fraction, new fraction EDX[26-0]
and 	edx,  eax 			; Fraction part
shr 	eax,  27 				; Next digit
add	ecx,  eax
add 	eax,  30h 			; Convert digit to ASCII
mov 	[edi], al 				; Store digit in memory.
lea	eax,  [edx*4+edx+0C0000000h] ; 5 * fraction, new digit EAX[31-26]
cmp 	ecx,  31h 			; Any nonzero digit yet?
mov 	edx,  3FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and               edx,  eax			;
shr 	eax,  26 				; Next digit
or	ecx, eax

mov 	[edi], al 				; Store digit in memory.\
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+60000000h] ; 5 * fraction, new digit EAX[31-25]
mov 	edx,  1FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and 	edx,  eax			; Fraction part
shr 	eax,  25 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+30000000h] ; 5 * fraction, new digit EAX[31-24]
mov 	edx,  0FFFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr, No, keep old ptr.
and	edx,  eax			;
shr 	eax,  24 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+18000000h] ; 5 * fraction, new digit EAX[31-23]
mov 	edx,  7FFFFFh 		; Fraction part

sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and	edx,  eax			;
shr 	eax,  23 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit out to memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+0C000000h] ; 5 * fraction, new digit EAX[31-22]
mov 	edx,  3FFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and               edx,  eax			;
shr 	eax,  22 				; Next digit
or	ecx, eax
mov 	[edi], al 				; Store digit in memory.
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+6000000h]  ; 5 * fraction, new digit EAX[31-21]
mov 	edx,  1FFFFFh 		; Fraction part
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
and 	edx,  eax			;
shr 	eax,  21 				; Next digit
mov 	[edi], al 				; Store digit in memory

or	ecx, eax
cmp 	ecx,  31h 			; Any nonzero digit yet?
lea 	eax,  [edx*4+edx+3000000h] ; 5 * fraction, new digit EAX[31-20]
sbb 	edi,   -1 				; Yes, increment ptr. No, keep old ptr.
shr 	eax,   20 			; Next digit
mov 	[edi],  ax 			; Store last digit and end marker in memory.
mov	edi,    [esp+2*4]		; Restore register as per calling convention
ret 	2*4 				; Pop two DWORD arguments and return
bin2asciiL	endp				; Total 88 instructions vs 101 from AMD
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;



comment *Binary-to-ASCII Decimal Conversion Suppressing Leading Zeros - AMD *
.code
option prologue:none  ; turn it off
option epilogue:none  ;
align  16             ;
bin2ascii proc lpbuf:DWORD, nNumber:DWORD
push 	edi 				; Save as per calling conventions.
push 	ebx 				; Save as per calling conventions.
mov 	edi,  [esp+2*4+1*4]		; sptr ->buffer
mov 	eax, [esp+2*4+2*4]		; x ->number
mov 	ecx, eax 			; Save original argument.
mov 	edx, 89705F41h 		; 1e-9 * 2^61 rounded
mul 	edx 				; Divide by 1e9 by multiplying with reciprocal.
add 	eax, eax 			; Round division result.
adc 	edx, 0 			; EDX[31-29] = argument / 1e9
shr 	edx, 29 			; Leading decimal digit, 0...4
mov 	eax, edx 			; Leading digit
mov 	ebx, edx 			; Initialize digit accumulator with leading digit.
imul 	eax, 1000000000 		; Leading digit * 1e9
sub 	ecx, eax 			; Subtract (leading digit * 1e9) from argument.
or 	dl,    '0' 			; Convert leading digit to ASCII.
mov 	[edi], dl 			; Store leading digit.
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
mov 	eax, ecx 			; Get reduced argument < 1e9.
mov 	edx, 0ABCC7712h 		; 2^28 / 1e8 * 2^30 rounded up
mul 	edx 				; Divide reduced
shr 	eax, 30 			; argument < 1e9 by 1e8,
lea 	edx, [eax+4*edx+1]	; converting it into 4.28 fixed-point
mov 	eax, edx 			; format such that 1.0 = 2^28.
shr 	eax, 28 			; Next digit
and 	edx, 0FFFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-27]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[26-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 27 			; Next digit
and 	edx, 7FFFFFFh 		; Fraction part
or	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-26]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[25-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 26 			; Next digit
and 	edx, 3FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-25]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[24-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 25 			; Next digit
and 	edx, 1FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-24]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[23-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr, No, keep old ptr.
shr 	eax, 24 			; Next digit
and 	edx, 0FFFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-23]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[31-23]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 23 			; Next digit
and 	edx, 7FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit out to memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-22]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[22-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 22 			; Next digit
and 	edx, 3FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit
or 	eax, '0'			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-21]
lea 	edx, [edx*4+edx] 		; 5 * fraction, new fraction EDX[21-0]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 21 			; Next digit
and 	edx, 1FFFFFh 		; Fraction part
or 	ebx, eax 			; Accumulate next digit.
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], al 			; Store digit in memory.
lea 	eax, [edx*4+edx] 		; 5 * fraction, new digit EAX[31-20]
cmp 	ebx, 1 			; Any nonzero digit yet?
sbb 	edi, -1 			; Yes, increment ptr. No, keep old ptr.
shr 	eax, 20 			; Next digit
or 	eax, '0' 			; Convert digit to ASCII.
mov 	[edi], ax 			; Store last digit and end marker in memory.
pop 	ebx 				; Restore register as per calling convention.
pop 	edi 				; Restore register as per calling convention.
ret 	2*4 				; Pop two DWORD arguments and return.
bin2ascii endp        ;
option prologue:prologuedef ; turn back on the defaults
option epilogue:epiloguedef ;

ALIGN 16
;
; syntax :
; eax = la valeur
; edi = adresse de la chaine de caractres  crer
; call uDw2Ascii
;
uDw2Ascii PROC
		push ebx									;; empiler ebx
		push edi									;; empiler edi

		mov ecx,eax								;; copier eax dans ecx
; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768							;; placer 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		sub edi,5									;; enlever 5 caractres  edi
		mul edx									;; multiplier eax par 2814749768
		shr edx,16								;; dcaler edx de 16 bits  droite
		mov eax,100000								;; placer 100000 dans eax
		mov ebx,edx								;; copier edx dans ebx
		mul edx									;; multiplier edx par 100000
		sub ecx,eax								;; soustraire le rsultat en eax  ecx
		test ebx,ebx								;; fixer les flags de ebx
		mov edx,ebx								;; replacer ebx dans edx
		mov ebx,10								;; placer 10 (notre multiplicateur dcimale) dans ebx
		jz Label01								;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497								;; on remplace eax par 429497
		add edi,5									;; ici, il y a plus de 5 caractres alors on rajoute les 5 qu'on avait enlev
		mul edx									;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label02								;; s'il existe un dpassement, aller Label02
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label03								;; s'il existe un dpassement, aller Label03
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label04								;; s'il existe un dpassement, aller Label04
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label05								;; s'il existe un dpassement, aller Label05
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label06								;; s'il existe un dpassement, aller Label06
		dec edi									;; dcrmenter l'adresse
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07								;; s'il existe un dpassement, aller Label07
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label08								;; s'il existe un dpassement, aller Label08
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label09								;; s'il existe un dpassement, aller Label09
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jc Label10								;; s'il existe un dpassement, aller Label10
		dec edi									;; dcrmenter l'adresse
		mul ebx									;; multiplier eax par 10
		jmp Label11								;; aller Label11
; ici, on va placer XXXXXXXXXX et le zro final
Label02:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label03:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+1],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label04:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+2],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label05:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+3],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label06:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+4],dl						;; placer l'octet en dl  l'adresse en edi
		mov eax,429497								;; on remplace eax par 429497
		mul ecx									;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
Label07:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+5],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label08:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+6],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label09:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+7],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label10:	add dl,30h								;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [edi+8],dl						;; placer l'octet en dl  l'adresse en edi
		mul ebx									;; multiplier eax par 10
Label11:	add dx,30h								;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [edi+9],dx						;; placer l'octet en dl et le 0 final en dh  l'adresse en edi

		pop edi									;; dsempiler edi
		pop ebx									;; dsempiler ebx
	ret											;; retourner (sortir de la procdure)
uDw2Ascii ENDP




.data
align 16
szBuffer   	db	30 Dup(0)

.code
; 
start:
; 
    ;function tests

    invoke	bin2ascii, addr szBuffer, 123456789
    print ADDR szBuffer,13,10
    invoke	bin2asciiL, addr szBuffer, 123456789
    print ADDR szBuffer,13,10
    mov eax, 123456789
    mov edi, OFFSET szBuffer
    call uDw2Ascii
    print ADDR szBuffer,13,10

    




    invoke Sleep, 4000

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	bin2ascii, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, bin2ascii-AMD",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    invoke	bin2asciiL, addr szBuffer, 0FFFFFFFEh
    counter_end
    print ustr$(eax)," cycles, bin2ascii-lingo",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    mov eax, 0FFFFFFFEh
    mov edi, OFFSET szBuffer
    call uDw2Ascii
    counter_end
    print ustr$(eax)," cycles, uDw2Ascii",13,10

    inkey "Press any key to exit..."
    exit
; 
end start



